﻿unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ComCtrls, ExtCtrls,
  UnitData, UnitFunc, UnitZumenTitle, UnitZumenPaper, UnitZumenLayer,
  UnitZumenColor, UnitZumenLtype, UnitZumenWidth, UnitZumenFont,
  UnitDataGraph, UnitGraph , UnitFuncCurve, Unit2 ;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    PaintBox1: TPaintBox;
    RadioGroup1: TRadioGroup;
    Button8: TButton;
    Label1: TLabel;
    Label2: TLabel;
    TreeView1: TTreeView;
    StatusBar1: TStatusBar;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Panel4: TPanel;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Button22: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button22Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
    AppPath : string ;
    docu : string ;
    procedure FTreeDisp ;
    procedure DisplayAll ;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// 起動時
procedure TForm1.FormShow(Sender: TObject);
begin
   AppPath := ExtractFilePath(Application.ExeName);
   docu  := '';
   CData := TDataClass.Create ;
   gp := TGraphClass.Create ;
   // Direct2D時、最初の描画が遅くなるため最初に一度実行しておく
   gp.SetDisplayMode(2);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_End ;
end;

// 終了時
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   gp.Free;
   CData.Free;
end;

// [図面情報｜図面表題欄の設定]
procedure TForm1.Button1Click(Sender: TObject);
begin
   FmZumenTitle.P_CData := CData ;
   FmZumenTitle.ShowModal ;
   if (FmZumenTitle.P_OK) then begin
      // OK
   end;
end;

// [図面構造｜用紙の設定]
procedure TForm1.Button2Click(Sender: TObject);
begin
   FmZumenPaper.P_CData := CData ;
   FmZumenPaper.ShowModal ;
   if (FmZumenPaper.P_OK) then begin
      // OK
   end;
end;

// [図面構造｜レイヤの設定]
procedure TForm1.Button3Click(Sender: TObject);
begin
   FmZumenLayer.P_CData := CData ;
   FmZumenLayer.ShowModal ;
end;

// [図面構造｜色の設定]
procedure TForm1.Button4Click(Sender: TObject);
begin
   FmZumenColor.P_CData := CData ;
   FmZumenColor.ShowModal ;
end;

// [図面構造｜線種の設定]
procedure TForm1.Button5Click(Sender: TObject);
begin
   FmZumenLtype.P_CData := CData ;
   FmZumenLtype.ShowModal ;
end;

// [図面構造｜線幅の設定]
procedure TForm1.Button6Click(Sender: TObject);
begin
   FmZumenWidth.P_CData := CData ;
   FmZumenWidth.ShowModal ;
end;

// [図面構造｜文字フォントの設定]
procedure TForm1.Button7Click(Sender: TObject);
begin
   FmZumenFont.P_CData := CData ;
   FmZumenFont.ShowModal ;
end;

// [描画]
procedure TForm1.Button8Click(Sender: TObject);
var
   tim : TTime ;
   x1,y1,x2,y2,col,ltp,wid,i : integer ;
   mc : integer ;
   lx1,ly1,lx2,ly2 : double ;
   lx,ly : array of double ;
   // fn : string ;
   //wx1,wx2,wx3,wx4, wx5,wx6,wx7,wx8, wx9 : double ;
   //wy1,wy2,wy3,wy4, wy5,wy6,wy7,wy8, wy9 : double ;
   //s : string ;
   //tx,ty,ta,ts,tl : double ;
   //e : TMatrix ;
   // st,ca:TStrGrid ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   ZInit;   // 関連する各変数の初期化

   Z2D(x1,y1, 0.0,0.0);
   Z2D(x2,y2, CData.zp.x,CData.zp.y);

   Label1.Caption := '左下：'+DStr(WndX1,2)+','+DStr(WndY1,2) ;
   Label2.Caption := '右上：'+DStr(WndX2,2)+','+DStr(WndY2,2) ;

   with CData do begin
      DataClearZukei ;  // 図形データクリア

      // 文字フォント
      if (zFntMax = 1) then begin
         AddFont(zFntMax+1, 'ＭＳ 明朝'      , 0,0);
         AddFont(zFntMax+1, 'ＭＳ Ｐゴシック', 0,0);
         AddFont(zFntMax+1, 'ＭＳ Ｐ明朝'    , 0,0);
      end;

      // 複合図形
      dFzk  := nil;
      dFzkN := 0;
      for i:=0 to fDefDN-1 do begin
         DataClearZukeiMember(i) ;
      end;
      fDefD := nil;
      fDefDN:= 0;
      fDef  := nil;
      fDefN := 0;

      AddFZukeiDef('部分図Ａ',1);      // XY座標系
      AddFZukeiDef('部分図Ｂ',2);      // YX座標系
      AddFZukeiDef('作図グループＣ',3);
      AddFZukeiDef('作図部品Ｄ',4);
      AddFZukeiDef('作図部品Ｅ',4);

      AddFZukeiDef('$$ATRF$$100',3);   // 属性のテスト用　図形識別番号＝100

      // シンボル定義
      DataClearSymbol ;
      DataInitSymbol ;
      AddSymbolDef('シンボルA');

      AddDataFZukei('',0,'部分図Ａ',200.0,250.0,30.0,1.5,1.2);
      AddDataFZukei('部分図Ａ',0,'作図グループＣ',50.0,50.0,30,1.0,1.0);   // 作図グループは引数を指定しても無効化される
      AddDataFZukei('作図グループＣ',0,'作図部品Ｄ',50.0,50.0,30,0.5,0.5);
      AddDataFZukei('',0,'部分図Ｂ',400.0,250.0,0.0,1.0,1.0);
      AddDataFZukei('部分図Ｂ',0,'作図部品Ｄ',10.0,20.0,0.0,2.0,1.0);
      AddDataFZukei('部分図Ｂ',0,'作図部品Ｅ',10.0,20.0,0.0,1.0,2.0);
      AddDataFZukei('作図部品Ｄ',0,'作図部品Ｅ',10.0,20.0,0.0,0.5,0.5);
      // AddDataFZukei('作図部品Ｅ',0,'作図部品Ｄ',0.0,0.0,0.0,1.0,1.0);
      // ↑このような指定をすると無限ループ状態になるので要注意

      AddDataFZukei('部分図Ａ',0,'$$ATRF$$100',0,0,0,1,1);  // 属性用の作図グループ
   end;

   FTreeDisp;     // 表示ツリー生成

   Screen.Cursor := crHourGlass ;
   tim := Now ;

   gp.SetDisplayMode(RadioGroup1.ItemIndex);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_Cls(Cdata.BackColor);
   // 用紙枠描画
   gp.G_SetPen(Cdata.PwakColor);
   gp.G_Line(x1,y1, x2,y1);
   gp.G_Line(x2,y1, x2,y2);
   gp.G_Line(x2,y2, x1,y2);
   gp.G_Line(x1,y2, x1,y1);

   CData.OpNext ; // 以下、１回目の操作

   // 点マーカ・データ登録テスト
   //    表記要素／用紙上に直接
   col := 1 ;
   mc  := 1 ;
   for i:=1 to 20 do begin
      lx1 := i*50 ;
      ly1 := 50.0 ;
      CData.AddDataTen('', 1,col,mc, lx1,ly1,0.0,15.0);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(mc);
      if (mc > 7) then mc := 1 ;
   end;

   // 点マーカ・データ登録テスト
   //    幾何要素／部分図以下に
   col := 1 ;
   mc  := 1 ;
   for i:=1 to 20 do begin
      lx1 := i*50 ;
      ly1 := 50.0 ;
      CData.AddDataTen('部分図Ａ', 1,col,mc, lx1,ly1,0.0,15.0);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(mc);
      if (mc > 7) then mc := 1 ;
   end;

   // シンボル図形テスト
   CData.AddDataTen( 'シンボルA', 1, 1,6, 0,0,0,5);
   CData.AddDataLine('シンボルA', 1,10,1,1, -10,-10,  10,-10);
   CData.AddDataLine('シンボルA', 1,11,1,1,  10,-10,  10, 10);
   CData.AddDataLine('シンボルA', 1,12,1,1,  10, 10, -10, 10);
   CData.AddDataLine('シンボルA', 1,13,1,1, -10, 10, -10,-10);
   CData.AddDataLine('シンボルA', 1,14,1,1, -10,-10,  10, 10);
   CData.AddDataLine('シンボルA', 1,15,1,1, -10, 10,  10,-10);

   CData.AddDataSZukei(''        , 1,0,0,'シンボル' , 100,50,0.0,1.0);   // シンボルなし
   CData.AddDataSZukei('部分図Ａ', 1,0,0,'シンボル' , 100,50,0.0,1.0);
   CData.AddDataSZukei(''        , 1,0,0,'シンボルA', 100,80,0.0,1.0);
   CData.AddDataSZukei('部分図Ａ', 1,0,0,'シンボルA', 100,80,0.0,1.0);
   CData.AddDataSZukei(''        , 1,1,2,'シンボルA', 130,80,30.0,0.5);
   CData.AddDataSZukei('部分図Ａ', 1,1,2,'シンボルA', 130,80,30.0,0.5);

   // 複合曲線＆ハッチングテスト
   SetLength(lx,5);
   SetLength(ly,5);
   CData.AddCCurveDef(1,5,5,8,1);      // 複合曲線定義 #1
   lx[0] :=   0;  ly[0] :=   0 ;
   lx[1] :=  90;  ly[1] :=   0 ;
   lx[2] := 120;  ly[2] :=-120 ;
   lx[3] :=  30;  ly[3] := -60 ;
   lx[4] :=   0;  ly[4] :=   0 ;
   CData.AddCCrvDataSpline(1,3,10,5,0.0,lx,ly);  // スプライン曲線
   lx := nil;
   ly := nil;
   // 右上がり斜線
   CData.AddDataHatch1(''        ,'sxf_hatch_style_1',1,1,1,0,[]);
   CData.AddDataHatch1('部分図Ａ','sxf_hatch_style_1',1,1,1,0,[]);

   CData.OpNext ;    // 以下、２回目の操作

   // 線分データ登録テスト
   //    表記要素／用紙上に直接
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 100.0 ;
      lx2 := lx1 ;
      ly2 := 200.0 ;
      CData.AddDataLine('', 1,col,ltp,wid, lx1,ly1,lx2,ly2);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpMax) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidMax) then wid := 1 ;
   end;

   // 線分データ登録テスト
   //    幾何要素／部分図以下に
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 100.0 ;
      lx2 := lx1 ;
      ly2 := 200.0 ;
      CData.AddDataLine('部分図Ａ', 1,col,ltp,wid, lx1,ly1,lx2,ly2);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpMax) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidMax) then wid := 1 ;
   end;

   // 補助線データ登録テスト     ※補助線はアンドゥ・リドゥ対象ではありません
   //    表記要素／用紙上に直接
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 0.0 ;
      lx2 := lx1 ;
      ly2 := 300.0 ;
      CData.AddHojoLine('', 1,3,5, lx1,ly1,lx2,ly2);
   end;
   //    幾何要素／部分図以下に
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 0.0 ;
      lx2 := lx1 ;
      ly2 := 300.0 ;
      CData.AddHojoLine('部分図Ａ', 1,3,5, lx1,ly1,lx2,ly2);
   end;

   DisplayAllData ;  // 全データ表示

   // showMessage('直前の補助線を20個削除します。[OK]をクリックして下さい');

   // 直前の補助線を20個 削除
   for i:=1 to 20 do begin
      CData.DelHojoPrev('');
      CData.DelHojoPrev('部分図Ａ');
   end;

   gp.G_End;
   gp.SetDisplayMode(RadioGroup1.ItemIndex);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_Cls(Cdata.BackColor);
   DisplayAllData ;  // 全データ表示

   // showMessage('全ての補助線を削除します。[OK]をクリックして下さい');

   // 全補助線を削除
   CData.DelHojoAll ;

   gp.G_End;
   gp.SetDisplayMode(RadioGroup1.ItemIndex);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_Cls(Cdata.BackColor);
   DisplayAllData ;  // 全データ表示

   // showMessage('直前の要素（線分）を20個削除します。[OK]をクリックして下さい');

   CData.OpNext ;    // 以下、３回目の操作

   // 直前の要素データを20個 削除
   for i:=1 to 20 do begin
      CData.DelDataPrev('');
      CData.DelDataPrev('部分図Ａ');
   end;

   gp.G_End;
   gp.SetDisplayMode(RadioGroup1.ItemIndex);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_Cls(Cdata.BackColor);
   DisplayAllData ;  // 全データ表示

{
   // ※画面が見えにくいのでコメント化しておきます

   // 折線データ登録テスト
   //    表記要素／用紙上に直接
   SetLength(lx,5);
   SetLength(ly,5);
   lx1 := 0.0 ;
   ly1 := 0.0 ;
   lx2 := 200.0 ;
   ly2 := 150.0 ;
   lx[0] := lx1 ; ly[0] := ly1 ;
   lx[1] := lx2 ; ly[1] := ly1 ;
   lx[2] := lx2 ; ly[2] := ly2 ;
   lx[3] := lx1 ; ly[3] := ly2 ;
   lx[4] := lx1 ; ly[4] := ly1 ;
   CData.AddDataLines('', 1,2,2,1, 5, lx,ly);

   // 折線データ登録テスト
   //    幾何要素／部分図以下に
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 5, lx,ly);

   for i:=0 to 3 do begin
      lx[i] := Random(100);
      ly[i] := Random(100);
   end;
   CData.AddDataLines('',         1,3,2,1, 4, lx,ly);
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 4, lx,ly);

   // ベジェ曲線テスト
   CData.AddDataBezier('',         1,4,4,3, 30,4, lx,ly);
   CData.AddDataBezier('部分図Ａ', 1,6,3,3, 30,4, lx,ly);

   SetLength(lx,10);
   SetLength(ly,10);

   for i:=0 to 9 do begin
      lx[i] := Random(100);
      ly[i] := Random(100);
   end;
   CData.AddDataLines('',         1,3,2,1, 10, lx,ly);
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 10, lx,ly);

   // ベジェ曲線テスト
   CData.AddDataBezier('',         1,4,4,3, 30,10, lx,ly);
   CData.AddDataBezier('部分図Ａ', 1,6,3,3, 30,10, lx,ly);

   SetLength(lx,10);
   SetLength(ly,10);

   for i:=0 to 3 do begin
      lx[i] := Random(100) + 100 ;
      ly[i] := Random(100);
   end;
   lx[4] := lx[0];   // 閉図形
   ly[4] := ly[0];
   CData.AddDataLines('',         1,3,2,1, 5, lx,ly);
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 5, lx,ly);

   // スプライン曲線に属性を付加→部分図Ａに配置

   // Ｂスプライン曲線テスト
   CData.AddDataBspline('',            1, 9,6,3, 30,5, lx,ly);
   CData.AddDataBspline('$$ATRF$$100', 1,10,5,3, 30,5, lx,ly);

   // スプライン曲線テスト
   CData.AddDataSpline('',            1, 9,7,1, 1,30,5, 0.5, lx,ly); // Cスプライン(点線)
   CData.AddDataSpline('$$ATRF$$100', 1, 9,7,1, 1,30,5, 0.5, lx,ly);
   CData.AddDataSpline('',            1, 2,2,3, 2,30,5, 0.0, lx,ly); // ベジェ補間（赤色）
   CData.AddDataSpline('$$ATRF$$100', 1, 2,2,3, 2,30,5, 0.0, lx,ly);
   CData.AddDataSpline('',            1, 4,4,3, 3,30,5, 0.0, lx,ly); // NUBS補間（青色）
   CData.AddDataSpline('$$ATRF$$100', 1, 4,4,3, 3,30,5, 0.0, lx,ly);

   // 属性付加
   CData.AddDataAttribute(100, '曲線タイプ','Ｂスプライン','STR','');
   CData.AddDataAttribute(100, '曲線タイプ','Ｃスプライン','STR','');
   CData.AddDataAttribute(100, '曲線タイプ','ベジェ補間'  ,'STR','');
   CData.AddDataAttribute(100, '曲線タイプ','ＮＵＢＳ補間','STR','');

   lx[0] :=  50;  ly[0] :=  50 ;
   lx[1] := 100;  ly[1] :=  50 ;
   lx[2] := 100;  ly[2] := 100 ;
   MtxSetE(e);
   TransSplineToLines(3,0,10,3, 0.5,lx,ly,e);
   s := IntToStr(tLnsN) + #13 + #10;
   for i:=0 to tLnsN-1 do
      s := s + DSTr(tLns[i].x,2) + ',' + DStr(tLns[i].y,2) + #13 + #10 ;
   showMessage(s);

   lx := nil;
   ly := nil;

   // 円データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*5 ;
      CData.AddDataCircle('', 1,col,ltp,wid,36, 0.0,50.0,lx1);
      CData.AddDataCircle('部分図Ａ', 1,col,ltp,wid,36, 0.0,50.0,lx1);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpMax) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidMax) then wid := 1 ;
   end;

   // 円弧データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*5 ;
      CData.AddDataArc('', 1,col,ltp,wid,36,0, 80.0,0.0,lx1,0.0,180.0);
      CData.AddDataArc('部分図Ａ', 1,col,ltp,wid,36,1, 80.0,0.0,lx1,0.0,180.0);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpMax) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidMax) then wid := 1 ;
   end;

   // 楕円データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5 ;
      CData.AddDataEllipse('', 1,col,ltp,wid,36, 150.0,50.0,lx1,ly1,30.0);
      CData.AddDataEllipse('部分図Ａ', 1,col,ltp,wid,36, 150.0,50.0,lx1,ly1,30.0);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpMax) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidMax) then wid := 1 ;
   end;

   // 楕円弧データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5 ;
      CData.AddDataEllipseArc('', 1,col,ltp,wid,36,0, 200.0,00.0,lx1,ly1,30.0,0.0,180.0);
      CData.AddDataEllipseArc('部分図Ａ', 1,col,ltp,wid,36,1, 200.0,0.0,lx1,ly1,30.0,0.0,180.0);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpMax) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidMax) then wid := 1 ;
   end;

   // 文字データ登録テスト
   col := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5 ;
   // CData.AddDataLine(''        , 1,col,0,6, lx1,-50,lx1,ly1);
   // CData.AddDataLine('部分図Ａ', 1,col,0,6, lx1,-50,lx1,ly1);
      CData.AddDataText(''        ,'ABCあいう絵ĂĠġĢģ〠〄亹仵', 1,col,1,1,1, lx1,ly1     , 10.0, 50.0, 0.0, -30.0, 0.0);
   // CData.AddDataText(''        ,'ABCdefghijklmn'          , 1,col,1,1,1, lx1,ly1+50.0, 10.0, 30.0, 0.0, -30.0, 0.0);
      CData.AddDataText('部分図Ａ','ABCあいう絵ĂĠġĢģ〠〄亹仵', 1,col,2,1,1, lx1,ly1     , 10.0, 50.0, 0.0, -30.0, 0.0);
   // CData.AddDataText('部分図Ａ','ABCdefghijklmn'          , 1,col,1,1,1, lx1,ly1+50.0, 10.0, 30.0, 0.0, -30.0, 0.0);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
   end;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5  + 20 ;
   // CData.AddDataLine(''        , 1,col,0,6, 0,ly1,lx1,ly1);
   // CData.AddDataLine('部分図Ａ', 1,col,0,6, 0,ly1,lx1,ly1);
      CData.AddDataText(''        ,'（ABCあいう）、，．『絵ĂĠġĢģ〠〄亹仵』。', 1,col,3,1,2, lx1,ly1     , 100.0, 10.0, 1.0, 30.0, 0.0);
   // CData.AddDataText(''        ,'ABCdefghijklmn'          , 1,col,3,1,2, lx1,ly1+50.0,  60.0, 20.0, 0.0, 30.0, 0.0);
      CData.AddDataText('部分図Ａ','【ABCあいう】、，．「絵ĂĠġĢģ〠〄亹仵」。', 1,col,4,1,2, lx1,ly1     , 100.0, 10.0, 0.0, 30.0, 0.0);
   // CData.AddDataText('部分図Ａ','ABCdefghijklmn'          , 1,col,4,1,2, lx1,ly1+50.0,  60.0, 20.0, 0.0, 30.0, 0.0);
      Inc(col);
      if (col > CData.zColMax) then col := 1 ;
   end;

   // クロソイド曲線テスト
   lx2 := 70.0 ;
   CData.AddDataClothoid(''         , 1,3,1,1,0,100, 100,50, lx2,0.0, 0.0,500.0);
   CData.AddDataClothoid('部分図Ａ' , 1,3,1,1,0,100, 100,50, lx2,0.0, 0.0,500.0);

   // シンボル図形テスト
   CData.AddDataTen( 'シンボルA', 1, 1,6, 0,0,0,5);
   CData.AddDataLine('シンボルA', 1,10,1,1, -10,-10,  10,-10);
   CData.AddDataLine('シンボルA', 1,11,1,1,  10,-10,  10, 10);
   CData.AddDataLine('シンボルA', 1,12,1,1,  10, 10, -10, 10);
   CData.AddDataLine('シンボルA', 1,13,1,1, -10, 10, -10,-10);
   CData.AddDataLine('シンボルA', 1,14,1,1, -10,-10,  10, 10);
   CData.AddDataLine('シンボルA', 1,15,1,1, -10, 10,  10,-10);

   CData.AddDataSZukei(''        , 1,0,0,'シンボル' , 100,50,0.0,1.0);   // シンボルなし
   CData.AddDataSZukei('部分図Ａ', 1,0,0,'シンボル' , 100,50,0.0,1.0);
   CData.AddDataSZukei(''        , 1,0,0,'シンボルA', 100,80,0.0,1.0);
   CData.AddDataSZukei('部分図Ａ', 1,0,0,'シンボルA', 100,80,0.0,1.0);
   CData.AddDataSZukei(''        , 1,1,2,'シンボルA', 130,80,30.0,0.5);
   CData.AddDataSZukei('部分図Ａ', 1,1,2,'シンボルA', 130,80,30.0,0.5);

   // 矢印データ登録テスト
   for i:=1 to 11 do begin
      lx1 := i * 20 ;
      ly1 := 20.0 ;
      lx2 := lx1 + 15*Cos(0/180.0*Pi) ;
      ly2 := ly1 + 15*Sin(0/180.0*Pi) ;
      CData.AddDataLine(''        , 1,2,1,1, lx1,ly1,lx2,ly2);
      CData.AddDataLine('部分図Ａ', 1,2,1,1, lx1,ly1,lx2,ly2);
      CData.AddDataLine(''        , 1,2,1,1, lx1,ly1,lx1,ly1-10);
      CData.AddDataLine('部分図Ａ', 1,2,1,1, lx1,ly1,lx1,ly1-10);

      CData.AddDataArrow(''        , 1,1,i, lx1,ly1,0.0,1.0);
      CData.AddDataArrow('部分図Ａ', 1,1,i, lx1,ly1,0.0,1.0);
   end;

   // 直線寸法テスト
   CData.AddDataDimLine('','123.456',1,1,1,1, 1,1,1,
      1,2, 1,2, 1,2,1, 25,120,135,120, 30,0,30,10,30,125, 130,0,130,10,130,125,
      30,120,1,  130,120,1, 80,123,10,50,0,0,0);
   CData.AddDataDimLine('部分図Ａ','123.456',1,1,1,1, 1,1,1,
      1,2, 1,2, 1,2,1, 25,120,135,120, 30,0,30,10,30,125, 130,0,130,10,130,125,
      30,120,1,  130,120,1, 80,123,10,50,0,0,0);

   // 角度寸法テスト
   wx1 := 80 +  10*Cos(30/180*Pi);
   wy1 := 80 +  10*Sin(30/180*Pi);
   wx2 := 80 +  20*Cos(30/180*Pi);
   wy2 := 80 +  20*Sin(30/180*Pi);
   wx3 := 80 + 100*Cos(30/180*Pi);
   wy3 := 80 + 100*Sin(30/180*Pi);
   wx4 := 80 + 110*Cos(30/180*Pi);
   wy4 := 80 + 110*Sin(30/180*Pi);

   wx5 := 80 +  10*Cos(120/180*Pi);
   wy5 := 80 +  10*Sin(120/180*Pi);
   wx6 := 80 +  20*Cos(120/180*Pi);
   wy6 := 80 +  20*Sin(120/180*Pi);
   wx7 := 80 + 100*Cos(120/180*Pi);
   wy7 := 80 + 100*Sin(120/180*Pi);
   wx8 := 80 + 110*Cos(120/180*Pi);
   wy8 := 80 + 110*Sin(120/180*Pi);

   wx9 := 80 + 105*Cos(75/180*Pi);
   wy9 := 80 + 105*Sin(75/180*Pi);
   lx1 := 75 - 90 ;

   CData.AddDataDimAngle('','10°20′30″',1,1,1,1,36, 1,1,1,
      1,2, 1,2, 1,2,1, 80,80,100,20,130, wx1,wy1,wx2,wy2,wx4,wy4, wx5,wy5,wx6,wy6,wx8,wy8,
      wx3,wy3,1,  wx7,wy7,1, wx9,wy9,10,50,0,lx1,0);
   CData.AddDataDimAngle('部分図Ａ','10°20′30″',1,1,1,1,36, 1,1,1,
      1,2, 1,2, 1,2,1, 80,80,100,20,130, wx1,wy1,wx2,wy2,wx4,wy4, wx5,wy5,wx6,wy6,wx8,wy8,
      wx3,wy3,1,  wx7,wy7,1, wx9,wy9,10,50,0,lx1,0);

   // 直径寸法テスト
   wx1 := 80.0 ;
   wy1 := 80.0 ;
   lx1 := 50.0 ;
   wx2 := wx1 + (lx1+10.0)*Cos(60.0/180.0*Pi);
   wy2 := wy1 + (lx1+10.0)*Sin(60.0/180.0*Pi);
   wx3 := wx1 + (lx1+10.0)*Cos((60.0+180.0)/180.0*Pi);
   wy3 := wy1 + (lx1+10.0)*Sin((60.0+180.0)/180.0*Pi);
   wx4 := wx1 + lx1*Cos(60.0/180.0*Pi);
   wy4 := wy1 + lx1*Sin(60.0/180.0*Pi);
   wx5 := wx1 + lx1*Cos((60.0+180.0)/180.0*Pi);
   wy5 := wy1 + lx1*Sin((60.0+180.0)/180.0*Pi);
   wx6 := (wx2+wx3)/2.0 + 2.0*Cos((60.0+90.0)/180.0*Pi);
   wy6 := (wy2+wy3)/2.0 + 2.0*Sin((60.0+90.0)/180.0*Pi);;
   s := 'φ' + DStr(lx1*2.0,1) ;
   ly1 := 5.0*Length(s);

   CData.AddDataCircle(''        , 1,1,1,8,36, wx1,wy1,lx1);
   CData.AddDataCircle('部分図Ａ', 1,1,1,8,36, wx1,wy1,lx1);
   CData.AddDataDimDiameter(''        ,s, 1,3,1,1, 1,
      6,2, 6,2, 1,2,1, wx2,wy2,wx3,wy3, wx4,wy4,1.5, wx5,wy5,1.5,
      wx6,wy6, 10,ly1,0.0,60.0,0);
   CData.AddDataDimDiameter('部分図Ａ',s, 1,3,1,1, 1,
      6,2, 6,2, 1,2,1, wx2,wy2,wx3,wy3, wx4,wy4,1.5, wx5,wy5,1.5,
      wx6,wy6, 10,ly1,0.0,60.0,0);

   SetLength(lx,5);
   SetLength(ly,5);
   for i:=0 to 4 do begin
      lx[i] := Random(100)+10;
      ly[i] := Random(100)+10;
   end;
   s   := 'バルーン' ;
   lx2 := 5.0*Length(s);
   ly2 := Sqrt(5.0*5.0/4.0+lx2*lx2/4.0) + 1.0 ;
   lx1 := lx[4] + ly2*Cos(Angle(lx[4]-lx[3],ly[4]-ly[3])) ;
   ly1 := ly[4] + ly2*Sin(Angle(lx[4]-lx[3],ly[4]-ly[3])) ;
   CData.AddDataDimBalloon('',         s, 1,4,2,1,36, 1,
      5, 6,1,5,1, lx,ly, lx1,ly1,ly2, 1.5, lx1,ly1, 10,lx2,0.0,0.0,0);
   CData.AddDataDimBalloon('部分図Ａ', s, 1,4,2,1,36, 1,
      5, 6,1,5,1, lx,ly, lx1,ly1,ly2, 1.5, lx1,ly1, 10,lx2,0.0,0.0,0);

   // シンボル図形テスト
   CData.AddDataTen( 'シンボルA', 1, 1,6, 0,0,0,5);
   CData.AddDataLine('シンボルA', 1,10,1,1, -5,-5,  5,-5);
   CData.AddDataLine('シンボルA', 1,11,1,1,  5,-5,  5, 5);
   CData.AddDataLine('シンボルA', 1,12,1,1,  5, 5, -5, 5);
   CData.AddDataLine('シンボルA', 1,13,1,1, -5, 5, -5,-5);
   CData.AddDataLine('シンボルA', 1,14,1,1, -5,-5,  5, 5);
   CData.AddDataLine('シンボルA', 1,15,1,1, -5, 5,  5,-5);

   SetLength(lx,5);
   SetLength(ly,5);
   CData.AddCCurveDef(1,1,1,1,1);      // 複合曲線定義 #1
   lx[0] :=  40;  ly[0] :=  40 ;
   lx[1] := 140;  ly[1] :=  40 ;
   lx[2] := 140;  ly[2] := 140 ;
   lx[3] :=  40;  ly[3] := 140 ;
   lx[4] :=  40;  ly[4] :=  40 ;
   CData.AddCCrvDataLines(1,5,lx,ly);  // 折線

   CData.AddCCurveDef(2,2,2,6,1);      // 複合曲線定義 #2
   CData.AddCCrvDataArc(2,36,0, 90,130,8,0,180);   // 円は円弧２つで形成
   CData.AddCCrvDataArc(2,36,0, 90,130,8,180,0);

   CData.AddCCurveDef(3,4,4,7,1);      // 複合曲線定義 #3
   lx[0] :=  60;  ly[0] :=  60 ;
   lx[1] :=  90;  ly[1] :=  90 ;
   lx[2] :=  60;  ly[2] := 120 ;
   lx[3] :=  60;  ly[3] :=  60 ;
   CData.AddCCrvDataSpline(3,3,10,4,0,lx,ly);  // スプライン曲線

   CData.AddCCurveDef(4,5,5,8,1);      // 複合曲線定義 #4
   lx[0] := 120;  ly[0] :=  60 ;
   lx[1] :=  90;  ly[1] :=  90 ;
   lx[2] := 120;  ly[2] := 120 ;
   lx[3] := 120;  ly[3] :=  60 ;
   CData.AddCCrvDataSpline(4,3,10,4,0,lx,ly);  // スプライン曲線

   lx := nil;
   ly := nil;

   // ----- ハッチングテスト -----
   // 右上がり斜線
   // CData.AddDataHatch1(''        ,'sxf_hatch_style_1',1,2,1,3,[2,3,4]);
   // CData.AddDataHatch1('部分図Ａ','sxf_hatch_style_1',1,2,1,3,[2,3,4]);

   // 右上がり斜線（破線）
   // CData.AddDataHatch1(''        ,'sxf_hatch_style_2',1,3,1,3,[2,3,4]);
   // CData.AddDataHatch1('部分図Ａ','sxf_hatch_style_2',1,3,1,3,[2,3,4]);

   // 水平線
   // CData.AddDataHatch1(''        ,'sxf_hatch_style_3',1,4,1,3,[2,3,4]);
   // CData.AddDataHatch1('部分図Ａ','sxf_hatch_style_3',1,4,1,3,[2,3,4]);

   // 水平線（破線）
   // CData.AddDataHatch1(''        ,'sxf_hatch_style_4',1,6,1,3,[2,3,4]);
   // CData.AddDataHatch1('部分図Ａ','sxf_hatch_style_4',1,6,1,3,[2,3,4]);

   // 斜線格子縞
   // CData.AddDataHatch1(''        ,'sxf_hatch_style_5',1,7,1,3,[2,3,4]);
   // CData.AddDataHatch1('部分図Ａ','sxf_hatch_style_5',1,7,1,3,[2,3,4]);

   // 斜線格子縞（破線）
   // CData.AddDataHatch1(''        ,'sxf_hatch_style_6',1,9,1,3,[2,3,4]);
   // CData.AddDataHatch1('部分図Ａ','sxf_hatch_style_6',1,9,1,3,[2,3,4]);

   // Area_Control　　ハッチング線無し
   // CData.AddDataHatch1(''        ,'Area_Control',1,1,1,3,[2,3,4]);
   // CData.AddDataHatch1('部分図Ａ','Area_Control',1,1,1,3,[2,3,4]);

   // 塗り
   // CData.AddDataHatch2(''        ,1,12,1,3,[2,3,4]);
   // CData.AddDataHatch2('部分図Ａ',1,12,1,3,[2,3,4]);

   // ユーザ定義
   // CData.AddDataHatch3(''        , 1, 1,[3],[1],[1],[0.0],[0.0],[4.01],[30.0], 1,3,[2,3,4]);
   // CData.AddDataHatch3('部分図Ａ', 1, 1,[3],[1],[1],[0.0],[0.0],[4.0],[30.0], 1,3,[2,3,4]);
   // CData.AddDataHatch3(''        , 1, 2,[3,4],[1,2],[1,1],[0.0,0.0],[0.0,0.0],[4.0,4.0],[30.0,150.0], 1,3,[2,3,4]);
   // CData.AddDataHatch3('部分図Ａ', 1, 2,[3,4],[1,2],[1,1],[0.0,0.0],[0.0,0.0],[4.0,4.0],[30.0,150.0], 1,3,[2,3,4]);

   // パターン
   // CData.AddDataHatch4(''        ,'シンボルA', 1,2, 50.0,50.0, 15,0, 15,90, 1.0,1.0,0.0,  1,3,[2,3,4]);
   // CData.AddDataHatch4('部分図Ａ','シンボルA', 1,2, 50.0,50.0, 15,0, 15,90, 1.0,1.0,0.0,  1,3,[2,3,4]);
   // CData.AddDataHatch4(''        ,'シンボルA', 1,2, 50.0,50.0, 15,0, 15,90, 1.0,1.0,15.0,  1,3,[2,3,4]);
   // CData.AddDataHatch4('部分図Ａ','シンボルA', 1,2, 50.0,50.0, 15,0, 15,90, 1.0,1.0,15.0,  1,3,[2,3,4]);
   // CData.AddDataHatch4(''        ,'シンボルA', 1,2, 50.0,50.0, 15,15, 15,75, 1.0,1.0,15.0,  1,3,[2,3,4]);
   // CData.AddDataHatch4('部分図Ａ','シンボルA', 1,2, 50.0,50.0, 15,15, 15,75, 1.0,1.0,15.0,  1,3,[2,3,4]);

   // CData.AddDataHatch4(''        ,'sxf_hatch_style_7_symbol', 1,2, 50.0,50.0, 20,0, 20,90, 0.1,0.1,0.0,  1,3,[2,3,4]);
   // CData.AddDataHatch4('部分図Ａ','sxf_hatch_style_7_symbol', 1,2, 50.0,50.0, 20,0, 20,90, 0.1,0.1,0.0,  1,3,[2,3,4]);
   // lx1 := 20.0*Sqrt(2.0);
   // CData.AddDataSZukei('' , 1,0,0,'sxf_hatch_style_8_symbol' , -50,50,0.0,0.1);  // 確認
   // CData.AddDataHatch4(''        ,'sxf_hatch_style_8_symbol', 1,2, 50.0,50.0, lx1,0, lx1,90, 0.1,0.1,0.0,  1,3,[2,3,4]);
   // CData.AddDataHatch4('部分図Ａ','sxf_hatch_style_8_symbol', 1,2, 50.0,50.0, lx1,0, lx1,90, 0.1,0.1,0.0,  1,3,[2,3,4]);

   CData.AddSymbolDef('シンボルB');
   // CData.AddDataLines('シンボルB', 1,1,1,1, 4, [0,10,5,0],[0,0,8,0]);
   // CData.AddDataCircle('シンボルB', 1,1,1,1, 36, 0.0,0.0,5.0);
   // CData.AddDataArc('シンボルB', 1,1,1,1, 18,0, 0.0,0.0,5.0,0.0,180.0);
   // CData.AddDataEllipse('シンボルB', 1,1,1,1, 36, 0.0,0.0,6.0,4.0,30.0);
   // CData.AddDataEllipseArc('シンボルB', 1,1,1,1, 18, 0, 0.0,0.0,6.0,4.0,30.0,0.0,180.0);
   // CData.AddDataBezier('シンボルB', 1,1,1,1, 10, 4,[0,3,6,9],[0,8,-8,0]);
   // CData.AddDataBspline('シンボルB', 1,1,1,1, 10,4, [0,3,6,9],[0,8,-8,0]);
   // CData.AddDataSpline('シンボルB', 1,1,1,1, 3,10,5, 0.0, [0,3,6,9,0],[0,6,-6,0,0]);
   // CData.AddDataClothoid('シンボルB', 1,1,1,1,0,30, 0,0, 10,0.0, 10.0,50.0);

   CData.AddDataTen('シンボルB', 1, 1,1,  0, 0 ,0, 1.0);
   CData.AddDataTen('シンボルB', 1, 1,2, -5, 5, 0, 1.0);
   CData.AddDataTen('シンボルB', 1, 1,3,  5, 5, 0, 1.0);
   CData.AddDataTen('シンボルB', 1, 1,4, -5,-5, 0, 1.0);
   CData.AddDataTen('シンボルB', 1, 1,5,  5,-5, 0, 1.0);
   CData.AddDataTen('シンボルB', 1, 1,6, -5, 0, 0, 1.0);
   CData.AddDataTen('シンボルB', 1, 1,7,  5, 0, 0, 1.0);

   for i:=1 to 11 do
      CData.AddDataArrow('シンボルB', 1,1,i, 0,(i-1)*4,0.0,1.0);

   CData.AddDataHatch4(''        ,'シンボルB', 1,10, 50.0,50.0, 20,0, 50,90, 1.0,1.0,0.0,  1,3,[2,3,4]);
   CData.AddDataHatch4('部分図Ａ','シンボルB', 1,10, 50.0,50.0, 20,0, 50,90, 1.0,1.0,0.0,  1,3,[2,3,4]);

   // 透過塗り
   CData.AddDataHatch5(''        ,1,12,128 ,1,3,[2,3,4]);
   CData.AddDataHatch5('部分図Ａ',1,12,128 ,1,3,[2,3,4]);

   // 線形グラデーション塗り
   CData.AddDataHatch6(''        ,1,2,3,255,0,30.0,0,0, 1,3,[2,3,4]);
   CData.AddDataHatch6('部分図Ａ',1,2,3,255,0,30.0,0,0, 1,3,[2,3,4]);

   // 円形グラデーション塗り 放射点＝中心
   CData.AddDataHatch6(''        ,1,2,3,128,1,0,0,0, 1,3,[2,3,4]);
   CData.AddDataHatch6('部分図Ａ',1,2,3,128,1,0,0,0, 1,3,[2,3,4]);

   // 円形グラデーション塗り 放射点＝中心
   CData.AddDataHatch6(''        ,1,2,3,128,2,0,50,50, 1,3,[2,3,4]);
   CData.AddDataHatch6('部分図Ａ',1,2,3,128,2,0,50,50, 1,3,[2,3,4]);

   // 画像塗り
   fn := AppPath + 'あ.jpg';
   // fn := AppPath + 'い.gif';
   // fn := AppPath + 'う.tif';
   // fn := AppPath + 'え.emf';
   CData.AddDataHatch7(''        ,fn,1,12, 1,3,[2,3,4]);
   CData.AddDataHatch7('部分図Ａ',fn,1,12, 1,3,[2,3,4]);

   // 画像
   fn := AppPath+'test.jpg' ;
   gp.G_ImageSize(y1,x1,fn);

   CData.AddDataImage(fn, 1,255, 20.0,200.0, 60.0,100.0, 30.0);
   // 縦横比率を1:1にしたい場合
   CData.AddDataImage(fn, 1,255, 60.0,200.0, 100.0,100.0*y1/x1, 15.0);
   // 透過（アルファ値指定）
   CData.AddDataImage(fn, 1,128,150.0,200.0, 100.0,100.0, 30.0);
   // 縦横比率を1:1にしたい場合
   CData.AddDataImage(fn, 1, 64,200.0,200.0, 100.0,100.0*y1/x1, 15.0);

   // 補助線データ登録テスト
   //    表記要素／用紙上に直接
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 0.0 ;
      ly2 := 300.0 ;
      CData.AddHojoLine('', 1,1,5, lx1,ly1,lx1,ly2);
   end;
   //    幾何要素／部分図以下に
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 0.0 ;
      ly2 := 300.0 ;
      CData.AddHojoLine('部分図Ａ', 1,1,5, lx1,ly1,lx1,ly2);
   end;

   CData.AddDataTen('', 1, 1,3, 10,200,0,5);
   CData.AddDataTen('部分図Ａ', 1, 1,3, 10,-100,0,5);

   SetLength(st,3,2);
   SetLength(ca,3,2);
   st[0,0] := 'あいう'; st[1,0] := 'ＡＢ';   st[2,0] := '100';
   st[0,1] := 'エオ';   st[1,1] := 'ＣＤＥ'; st[2,1] := '50';
   ca[0,0] := '';    ca[1,0] := '';    ca[2,0] := '';
   ca[0,1] := '';    ca[1,1] := '';    ca[2,1] := '';
   CData.AddDataTable(''        ,1,1, 3,2,1,1, 0,0,0, 15,1,16,1, 0,0, 100.0,50.0,1.0,1.0,
      [40,30,30],[10,10], [1,2,3], st, ca);
   CData.AddDataTable('部分図Ａ',1,1, 3,2,1,1, 0,0,0, 15,1,16,1, 0,0, 100.0,50.0,1.0,1.0,
      [40,30,30],[10,10], [1,2,3], st, ca);
   st := nil ;
   ca := nil ;
}
   DisplayAllData ;  // 全データ表示

   gp.G_End;

   Screen.Cursor := crDefault ;
   LongTimeFormat := 'hh:nn:ss.zzz';
   StatusBar1.SimpleText := TimeToStr(Now-tim);
end;

// [描画]
procedure TForm1.Button9Click(Sender: TObject);
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   ZInit;   // 関連する各変数の初期化

   DisplayAll ;
end;

// 描画
procedure TForm1.DisplayAll ;
var
   tim : TTime ;
   x1,y1,x2,y2 : integer ;
begin
   Z2D(x1,y1, 0.0,0.0);
   Z2D(x2,y2, CData.zp.x,CData.zp.y);

   Label1.Caption := '左下：'+DStr(WndX1,2)+','+DStr(WndY1,2) ;
   Label2.Caption := '右上：'+DStr(WndX2,2)+','+DStr(WndY2,2) ;

   Screen.Cursor := crHourGlass ;
   tim := Now ;

   gp.SetDisplayMode(RadioGroup1.ItemIndex);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_Cls(Cdata.BackColor);
   // 用紙枠描画
   gp.G_SetPen(Cdata.PwakColor);
   gp.G_Line(x1,y1, x2,y1);
   gp.G_Line(x2,y1, x2,y2);
   gp.G_Line(x2,y2, x1,y2);
   gp.G_Line(x1,y2, x1,y1);

   DisplayAllData ;  // 全データ表示

   gp.G_End;

   Screen.Cursor := crDefault ;
   LongTimeFormat := 'hh:nn:ss.zzz';
   StatusBar1.SimpleText := TimeToStr(Now-tim);
end;

// 複合図形ツリー表示
procedure TForm1.FTreeDisp ;
var
   i,j : integer ;
   p : TTreeNode ;
begin
   CData.MakeFZukeiTree ;
   TreeView1.Items.Clear ;
   TreeView1.Items.Add(nil,'用紙');
   for i:=0 to CData.zFztN-1 do begin
      j := Cdata.zFzt[i].par ;
      p := TreeView1.Items[j+1] ;
      TreeView1.Items.AddChild(p, Cdata.zFzt[i].name);
   end;
end;

// [文章入力]
procedure TForm1.Button10Click(Sender: TObject);
var
   s : string ;
begin
   if (CData.zLayMax = 0) then begin
      ShowMessage('最初に一度[登録]を行って下さい。');
      exit ;
   end;

   Form2.docs := docu ;
   Form2.ShowModal ;
   docu := Form2.docs ;
   // ShowMessage(docu);
   s := GetPlainText(docu);
   // ShowMessage(s);
   s := KTrim(s);
   // ShowMessage(s);

   with CData do begin
      AddDataDocument('',docu, 1,7,1, 10,200, 72,100,1.0,2.0,0.0);
      AddDataDocument('部分図Ａ',docu, 1,7,1, 10,-100, 72,100,1.0,2.0,0.0);
      // 縦書き（縦書きの場合は「＠」付きのフォントを使用して下さい）
      AddDataDocument('',docu, 1,1,2, 10,200, 72,100,1.0,2.0,0.0);
      AddDataDocument('部分図Ａ',docu, 1,1,2, 10,-100, 72,100,1.0,2.0,0.0);
   end;
end;

// [アンドゥ]
procedure TForm1.Button11Click(Sender: TObject);
begin
   if not(CData.CheckOpUndo) then begin
      showMessage('アンドゥできません');
      exit ;
   end;
   CData.OpUndo ;
   FTreeDisp ;    // 表示ツリー生成
   Button9Click(Sender);   // 描画
end;

// [リドゥ]
procedure TForm1.Button12Click(Sender: TObject);
begin
   if not(CData.CheckOpRedo) then begin
      showMessage('リドゥできません');
      exit ;
   end;
   CData.OpRedo ;
   FTreeDisp ;    // 表示ツリー生成
   Button9Click(Sender);   // 描画
end;

// [テスト]
procedure TForm1.Button13Click(Sender: TObject);
var
   // 複合図形定義　削除テスト
   // i : integer ;
   // 複合図形定義　編集テスト
   // ex : Boolean ;
   // s : string ;
   // i,f,cn,dn : integer ;
   // シンボル図形定義　削除テスト
   // i : integer ;
   // シンボル図形定義　編集テスト
   // ex : Boolean ;
   // s : string ;
   // i,cn,dn : integer ;
   // 複合曲線定義　削除テスト
   // i : integer ;
   // 複合曲線定義　編集テスト
   // ex : Boolean ;
   // n,id,col,ltp,wid,inv,cn,dn : integer ;
   // 点マーカ　編集テスト
   ex : Boolean ;
   lay,col,mc,i : integer ;
   lx,ly,la,ls : double ;
begin
   if (CData.zLayMax = 0) then begin
      ShowMessage('最初に一度[登録]を行って下さい。');
      exit ;
   end;

   CData.OpNext ;

   // 複合図形定義　削除テスト
   // i := CData.FZukeiNameCheck(0,'部分図Ａ') - 1 ;  // 以下、要素Indexで扱うので-1する
   // CData.DelFZukeiDef(i);

   // 複合図形定義　編集テスト
   // i := CData.FZukeiNameCheck(0,'部分図Ａ') - 1 ;  // 以下、要素Indexで扱うので-1する
   // CData.GetFZukeiDef(i,ex,s,f,cn,dn);
   // CData.EditFZukeiDef(i,s,3-f,cn,dn);    // 数学座標系←→測地座標系

   // シンボル図形定義　削除テスト
   // i := - CData.FZukeiNameCheck(0,'シンボルA') - 1 ;  // 以下、要素Indexで扱うので
   // CData.DelSymbolDef(i);

   // シンボル図形定義　編集テスト
   // i := - CData.FZukeiNameCheck(0,'シンボルA') - 1 ;  // 以下、要素Indexで扱うので
   // CData.GetSymbolDef(i,ex,s,cn,dn);
   // CData.EditSymbolDef(i,'シンボルダミー',cn,dn);     // シンボル図形配置でのシンボル図形名を変更していないので無定義状態になる

   // 複合曲線定義　削除テスト
   // i := CData.CCrvIDCheck(1) ;
   // CData.DelCCurveDef(i);

   // 複合曲線定義　編集テスト
   // n := CData.CCrvIDCheck(1) ;
   // if (CData.GetCCurveDef(n,ex,id,col,ltp,wid,inv,cn,dn)) then
   //    CData.EditCCurveDef(n,id,2,ltp,wid,inv,cn,dn);     // 色を変えてみる

   // 点マーカ　編集テスト
   if (CData.GetDataTen('', 0, ex,lay,col,mc, lx,ly,la,ls)) then
      CData.EditDataTen('', 0, lay,col,mc, lx,ly,la,ls*3.0);

   // 部分図配置　編集テスト
   CData.OpNext ;
   CData.EditDataFZukei('',0, 0,'部分図Ａ',200.0,200.0, 20.0,1.4,1.2);
   CData.OpNext ;
   i := CData.dFzkN - 1;
   CData.EditDataFZukei('',i, 0,'部分図Ａ',200.0,150.0, 10.0,1.2,1.1);
   CData.OpNext ;
   i := CData.dFzkN - 1;
   CData.EditDataFZukei('',i, 0,'部分図Ａ',200.0,100.0,  0.0,1.0,1.0);

   FTreeDisp ;    // 表示ツリー生成
   Button9Click(Sender);   // 描画
end;

// [定規倍率表示]
procedure TForm1.Button14Click(Sender: TObject);
var
   xdot : integer ;
   xmm,xx,yy  : double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   CenX := ScrX div 2;    // 画面中央
   CenY := ScrY div 2;

   xdot := Screen.Width ;  // モニタの横幅ドット数
   xmm  := 478.0;          // 20.5 ワイドディスプレイでの横幅目分量です
   mm_dot := xdot/xmm ;
   // 画面中央を基準として拡大縮小します
   xx := (WndX1+WndX2)/2.0 ;
   yy := (WndY1+WndY2)/2.0 ;
   WndX1 := xx - ScrX/mm_dot/2.0 ;
   WndX2 := xx + ScrX/mm_dot/2.0 ;
   WndY1 := yy - ScrY/mm_dot/2.0 ;
   WndY2 := yy + ScrY/mm_dot/2.0 ;

   DisplayAll ;
end;

// [２倍拡大表示]
procedure TForm1.Button15Click(Sender: TObject);
var
   xx,yy  : double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   CenX := ScrX div 2;    // 画面中央
   CenY := ScrY div 2;

   mm_dot := 2.0 * mm_dot ;
   // 画面中央を基準として拡大縮小します
   xx := (WndX1+WndX2)/2.0 ;
   yy := (WndY1+WndY2)/2.0 ;
   WndX1 := xx - ScrX/mm_dot/2.0 ;
   WndX2 := xx + ScrX/mm_dot/2.0 ;
   WndY1 := yy - ScrY/mm_dot/2.0 ;
   WndY2 := yy + ScrY/mm_dot/2.0 ;

   DisplayAll ;
end;

// [1/2倍縮小表示]
procedure TForm1.Button16Click(Sender: TObject);
var
   xx,yy  : double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   CenX := ScrX div 2;    // 画面中央
   CenY := ScrY div 2;

   mm_dot := 0.5 * mm_dot ;
   // 画面中央を基準として拡大縮小します
   xx := (WndX1+WndX2)/2.0 ;
   yy := (WndY1+WndY2)/2.0 ;
   WndX1 := xx - ScrX/mm_dot/2.0 ;
   WndX2 := xx + ScrX/mm_dot/2.0 ;
   WndY1 := yy - ScrY/mm_dot/2.0 ;
   WndY2 := yy + ScrY/mm_dot/2.0 ;

   DisplayAll ;
end;

// [↑移動表示]
procedure TForm1.Button17Click(Sender: TObject);
var
   l : double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   CenX := ScrX div 2;    // 画面中央
   CenY := ScrY div 2;

   l := Abs(WndY2-WndY1)/4.0 ;
   WndY1 := WndY1 + l ;
   WndY2 := WndY2 + l ;

   DisplayAll ;
end;

// [←移動表示]
procedure TForm1.Button18Click(Sender: TObject);
var
   l : double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   CenX := ScrX div 2;    // 画面中央
   CenY := ScrY div 2;

   l := Abs(WndX2-WndX1)/4.0 ;
   WndX1 := WndX1 - l ;
   WndX2 := WndX2 - l ;

   DisplayAll ;
end;

// [→移動表示]
procedure TForm1.Button19Click(Sender: TObject);
var
   l : double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   CenX := ScrX div 2;    // 画面中央
   CenY := ScrY div 2;

   l := Abs(WndX2-WndX1)/4.0 ;
   WndX1 := WndX1 + l ;
   WndX2 := WndX2 + l ;

   DisplayAll ;
end;

// [↓移動表示]
procedure TForm1.Button20Click(Sender: TObject);
var
   l : double ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   CenX := ScrX div 2;    // 画面中央
   CenY := ScrY div 2;

   l := Abs(WndY2-WndY1)/4.0 ;
   WndY1 := WndY1 - l ;
   WndY2 := WndY2 - l ;

   DisplayAll ;
end;

// [Ｃ（中央）移動表示]
procedure TForm1.Button21Click(Sender: TObject);
var
   m,xx,yy  : double ;
begin
   m := mm_dot ;
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   ZInit;   // 関連する各変数の初期化

   mm_dot := m ;

   xx := (WndX1+WndX2)/2.0 ;
   yy := (WndY1+WndY2)/2.0 ;
   WndX1 := xx - ScrX/mm_dot/2.0 ;
   WndX2 := xx + ScrX/mm_dot/2.0 ;
   WndY1 := yy - ScrY/mm_dot/2.0 ;
   WndY2 := yy + ScrY/mm_dot/2.0 ;

   DisplayAll ;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if (Key = VK_HOME) then begin
      // 描画
      Button9Click(Sender);
	   Key := 0 ;
   end
   else if (Key = VK_PRIOR) then begin
		// PageUp：２倍拡大表示
      Button15Click(Sender);
	   Key := 0 ;
   end
   else if (Key = VK_NEXT) then begin
		// PageDown：1/2倍縮小表示
      Button16Click(Sender);
	   Key := 0 ;
   end
   else if (Key = VK_UP) then begin
      // ↑
      Button17Click(Sender);
	   Key := 0 ;
   end
   else if (Key = VK_LEFT) then begin
      // ←
      Button18Click(Sender);
	   Key := 0 ;
   end
   else if (Key = VK_RIGHT) then begin
      // →
      Button19Click(Sender);
	   Key := 0 ;
   end
   else if (Key = VK_DOWN) then begin
      // ↓
      Button20Click(Sender);
	   Key := 0 ;
   end
   else if (Key = VK_END) then begin
      // Ｃ
      Button21Click(Sender);
	   Key := 0 ;
   end;
end;

// 基準表示に対する倍率表示
procedure TForm1.Button22Click(Sender: TObject);
var
   n,xx,yy  : double ;
begin
   n := SDbl(Edit2.Text);
   if (n < 0.000001) then n := 0.000001 ;
   if (n > 100000.0) then n := 100000.0 ;

   xx := (WndX1+WndX2)/2.0 ;
   yy := (WndY1+WndY2)/2.0 ;

   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   ZInit ;
   mm_dot := n * mm_dot ;

   // 画面中央を基準として拡大縮小します
   WndX1 := xx - ScrX/mm_dot/2.0 ;
   WndX2 := xx + ScrX/mm_dot/2.0 ;
   WndY1 := yy - ScrY/mm_dot/2.0 ;
   WndY2 := yy + ScrY/mm_dot/2.0 ;

   DisplayAll ;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #13) then begin
      Button22Click(Sender);
      Key := #0 ;
   end;
end;

end.
